#!/usr/bin/python
# -*- coding: utf-8 -*-

import sys,os
import pynotify
import socket,re,urllib

def pushNotification (title, body, icon):
  n = pynotify.Notification (title, body, icon);
  n.set_hint_string ("x-canonical-append", "");
  n.show ()

def server():
  s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)   #initializing connection
  s.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
  #вешаемя на 8091 порт
  s.bind(('127.0.0.1',8091))
  print "Waiting for connections..."
  s.listen(5)

  while 1:
      #принимаем соединение
      clientsock, clientaddr = s.accept()
      print "Got connection from", clientsock.getpeername()
      clientsock.sendall("HTTP/1.0 200 OK\r\n")

      req = clientsock.recv(1024) #считываем весь запрос

      get=re.findall(r"GET /(.*) HTTP/1.",req)
      #получаем get (после слеша в запрашиваемом адресе)

      if get:
        #парсим сообщение
        icon,sender,message=urllib.url2pathname(get[0]).strip("'").split("' '")
        #print message+" "+sender
        pushNotification(sender,message,icon);

      #Посылаем ok, что-бы wget не расстраивался
      clientsock.sendall("Content-Type: text/html\r\n")
      clientsock.sendall("Content-Length: " + str(len("ok")) + "\r\n")
      clientsock.sendall("\r\n")
      clientsock.sendall("ok")

      clientsock.close()


if __name__ == '__main__':
  if not pynotify.init ("append-hint-example"):
    sys.exit (1)

  server()

